import { Dimension, Player, EntityQueryOptions, world} from "@minecraft/server"
import { rawtext, runcmd } from "../AbstractTools.js"
import { abstractSTRGtarget } from "../AbsctractStorage/index.js"
import { PREFIX, PREFIX2 } from "./index.js"

export const iList = ['stats', 'db', 'debug', 'mapreload', 'emojis', 'help', 'reset']
export const iListAllies = {
    "reload": "mapreload"
}
//NO_DATA - hidden, ! - need op 
export const iListFunctions = {
    'stats': '{"translate":"js.icommand.description.stats"}',
    'db': '{"translate":"js.icommand.description.db"}',
    'debug': '{"translate":"js.icommand.description.debug"}',
    'mapreload': '!{"translate":"js.icommand.description.reload"}',
    'emojis': '{"translate":"js.icommand.description.emojis"}',
    'reset': '{"translate":"xyz.minecrafter.reset.board"}',
    'help': 'NO_DATA',
    'taglist': 'NO_DATA'
}
export const iListProMAX = ['gmc', 'gma', 'eco', 'op', 'inv', 'deinv', 'eval', 'kill', 'ntags', 'tags']

export function iArgument (msg, num) {
    return msg.split(" ")[num]
}

export async function iCommand(target, msg) {
    let name = target.nameTag
    let iCMDname = msg.substring(1).split(" ")[0]
    if (iList.includes(iCMDname)) {
        let { iRUN } = await import(`./cmd/${iCMDname}.js`)
        try{iRUN(target, msg)}catch(e){console.error(e)}
    } else if (iListAllies.includes(iCMDname)) {
        rawtext('ALLI')
        let { iRUN } = await import(`./cmd/${iListAllies[iCMDname]}.js`)
        try{iRUN(target, msg)}catch(e){console.error(e)}
    } else {
        runcmd(`tellraw "${name}" {"rawtext":[{"text":"§c"},{"translate":"commands.generic.unknown","with":["\\${PREFIX}${iCMDname}"]}]}`)
    }
}

export async function iCommandProMAX(target, msg) {
    let name = target.nameTag
    let iCMDname = msg.substring(1).split(" ")[0]
    if (iListProMAX.includes(iCMDname) && await abstractSTRGtarget(target, 'db.dev')) {
        let { iRUN } = await import(`./cmd/pro/${iCMDname}.js`)
        try{iRUN(target, msg)}catch(e){console.error(e)}
    } else if (!await abstractSTRGtarget(target, 'db.dev')) {
        runcmd(`tellraw "${name}" {"rawtext":[{"text":"§c"},{"translate":"xyz.minecrafter.noperm"}]}`)
    } else {
        runcmd(`tellraw "${name}" {"rawtext":[{"text":"§c"},{"translate":"commands.generic.unknown","with":["${PREFIX2}${iCMDname}"]}]}`)
    }
}