/*
Created by Axisander, Lndrs_ (Lndrs2224)
Description: AbstractChat
©️ AxisCube 2022
*/

import { world } from "@minecraft/server"
import { playsound, tellraw, runcmd, getScore, hasTag } from "../AbstractTools.js"
import { CodeToEmoji } from './AbstractUnicode.js'
import { iCommandProMAX, iCommand } from './iCommand.js'


const ARROW_SYMBOL = '\ue170'
export const PREFIX = '\\'
export const PREFIX2 = '`'
export const PREFIX_TEAM = '!'

export function parse_msg(msg, target){
    if (msg == 'gg' || msg == 'пп' || msg == 'GG' || msg == 'Gg' || msg == 'Пп') {
        msg = '§l§cGG!'
    }
    //Profanity
    //Position
    msg = msg.replace(/\$\{pos\}/, `§c${Math.floor(target.location.x)} §a${Math.floor(target.location.y)} §9${Math.floor(target.location.z)}§r`)
    msg = msg.replace(/\$\{\x\}/, `§c${Math.floor(target.location.x)}§r`).replace(/\$\{\y\}/, `§a${Math.floor(target.location.y)}§r`).replace(/\$\{\z\}/, `§9${Math.floor(target.location.z)}§r`)
    // qwerty -> йцукен
    msg = msg.replace(/jr/g, 'ок').replace(/щл/g, 'ok').replace(/lf/g, 'да').replace(/ytn/g, 'нет').replace(/\[vvv/g, 'хммм').replace(/\[vv/g, 'хмм').replace(/\[p/g, 'хз')
    // :) -> Emoji
    msg = msg.replace(/\:\)/g, '\ue1f0').replace(/\:-\)/g, '\ue1f0').replace(/\:-\(/g, '\ue1f3').replace(/\:\(/g, '\ue1f3')
    // :sad: -> Emoji
    msg = CodeToEmoji(msg, target)
    // fix \ and "
    msg = msg.replace(/\\/g, '\\\\').replace(/\"/g, `\\"`)
    return msg
}

function time_prefix(){
	const date = new Date()
    if (getScore('settings', 'chat_time') == 1) {
        return `§7[${date.getHours()+getScore('settings', 'time_gmt')}:${date.getMinutes()}:${date.getSeconds()}]§r `
    } else if (getScore('settings', 'chat_time') == 2) {
         return `§7[${date.getHours()+getScore('settings', 'time_gmt')}:${date.getMinutes()}]§r `
    } else {
         return ''
    }
}

function send_msg(msg, msg_recipient, msg_sender_target, name_color = '§r', PREFIX = '', suffix = ''){
    let msg_sender = msg_sender_target.nameTag
    playsound('random.pop', `@a[name=!"${msg_sender}"]`, 0.5)
    playsound('random.pop', `@a[name="${msg_sender}"]`, 0.5, 0.7)
    tellraw(`{"rawtext":[{"text":"${PREFIX}"},{"text":"${time_prefix()}"},{"text":"${suffix}"},{"text":"${name_color}"},{"text":"${msg_sender}§r"},{"text":" ${ARROW_SYMBOL} "},{"text":"${parse_msg(msg, msg_sender_target)}"}]}`, msg_recipient)
}

const team_prefixes = {
        'bw_green': "\ue140",
        'bw_blue': "\ue121",
        'flagw_blue': "\ue121",
        'flagw_red': "\ue120",
        'bw_yellow': "\ue122",
        'bw_red': "\ue120"
}

const color_pallete = {
        'bw_green': "§a",
        'bw_blue': "§9",
        'bw_yellow': "§g",
        'bw_red': "§c",
        'flagw_red': "§c",
        'flagw_blue': "§9"
}

world.events.beforeChat.subscribe((iMessage) => {
    let msg_sender = iMessage.sender.name
    let msg_sender_target = iMessage.sender
    let msg = iMessage.message
    if(!msg.startsWith(PREFIX2) && !msg.startsWith(PREFIX)) {
        iMessage.cancel = true
        let msg = iMessage.message
        for (let tag in team_prefixes) {
            if (team_prefixes.hasOwnProperty(tag)) {
                let tag_test = iMessage.sender.hasTag(tag)
                let tag_ownerCount = 0
                if (tag_test) {
                    for (let i = 0; i != [...world.getPlayers()].length; i++){
                        let currentTarget = [...world.getPlayers()][i]
                        if (hasTag(currentTarget, tag)) {
                            tag_ownerCount++
                        }
                    }
                }
                 if(tag_test && !msg.startsWith(PREFIX_TEAM) && tag_ownerCount > 1){
                    send_msg(msg, `@a[tag=${tag}]`, msg_sender_target, color_pallete[tag], `${team_prefixes[tag]} `, `§7[§dTeam§7] `)
                    var has_team_tags = true
                    var fix = true
                } else if((tag_test && msg.startsWith(PREFIX_TEAM)) || tag_ownerCount == 1){
                    if (tag_ownerCount != 1) {msg = msg.substring(1)}
                    send_msg(msg, `@a`, msg_sender_target, color_pallete[tag], `${team_prefixes[tag]} `, `§7[§5Global§7] `)
                    var has_team_tags = true
                    var fix = true
                } else if(!tag_test && !fix){
                    var has_team_tags = false
                }
            }
        }
        if(!has_team_tags){
            send_msg(msg, '@a', msg_sender_target)
        }
    } else if (msg.startsWith(PREFIX2)) {
        iMessage.cancel = true
        iCommandProMAX(msg_sender_target, msg)
    } else if (msg.startsWith(PREFIX)) {
        iMessage.cancel = true
        iCommand(msg_sender_target, msg)
    }
})