import {
    ActionFormData,
    ActionFormResponse,
    MessageFormData,
    ModalFormData
  } from "@minecraft/server-ui";
import { Dimension, Player, world } from "@minecraft/server";
import {playsound, randomInt, runcmd, getScore, arrayPlayers, tellraw, showCaptcha, rawtext, getItemAmounts} from "../AbstractTools.js";
import {abstractSTRGbank} from "../AbsctractStorage/index.js";

export function getBalance( target, useZero = false) {
    try {
        const oB = world.scoreboard.getObjective('minecrafter.xyz')
        if (typeof target == 'string') return oB.getScore(oB.getParticipants().find(pT => pT.displayName == target))
        return oB.getScore(target.scoreboard)
    } catch {
        return useZero ? 0 : NaN
    }
}

export function addBalance(name, num) {
    runcmd(`scoreboard players add "${name}" minecrafter.xyz ${num}`)
}

export function setBalance(name, num) {
    runcmd(`scoreboard players set "${name}" minecrafter.xyz ${num}`)
}

export const banks = ['%axiscube.bank.axisbank', 'XYZ-Bank', 'AbstractBanking Inc.']
export const banks_json = ['{"translate":"axiscube.bank.axisbank"}', '{"text":"XYZ-Bank"}', '{"text":"AbstractBanking Inc."}']
export const payment_systems = ['GG++', 'MineCard', 'AxisWorld']
export const payment_systems_starts = [4, 5, 2]
export const payment_systems_logo = ['\ue121', '\ue120', '\ue140']
const code_pattern = /^[0-9]{4,4}$/

function axisbank_deposit(target) {
    try{
        let res_amounts = getItemAmounts(target, ["mcxyz:emerald_big", 'mcxyz:emerald_small'])
        let name = target.nameTag
        let big_em = res_amounts["mcxyz:emerald_big"]
        let small_em = res_amounts["mcxyz:emerald_small"]
        if(big_em > 0 ){
            runcmd(`clear "${name}" mcxyz:emerald_big -1 ${big_em}`)
            addBalance(name, 100*big_em)
            playsound('emerald.use', name)
        }
        if(small_em > 0 ){
            runcmd(`clear "${name}" mcxyz:emerald_small -1 ${small_em}`)
            addBalance(name, 10*small_em)
            playsound('emerald.use', name)
        }
        tellraw(`{"rawtext":[{"translate":"axiscube.msg.emerald.deposit","with":{"rawtext":[{"text":"${name}"},{"text":"${small_em}"},{"text":"${big_em}"},{"text":"${abstractSTRGbank(target, 'bank_full')}"}]}}]}`, name)
    }catch(err){console.error('О НЕТ! ВЫ СЛОМАЛИ 99999182398098 СТРОК КОДА И ЭТО ВЫЗВАЛО ОШИБКУ -->')}
}

function axisbank_cash_out(target) {
    let name = target.nameTag
    let emer_has = getBalance(name)

    emer_has = Number(emer_has)
    emer_has = Math.floor(emer_has / 10)
    emer_has = emer_has * 10

    const form = new ModalFormData()
        form.title("%axiscube.bank.atm")
        form.slider("%axiscube.bank.action.cash_out.text2", 10, emer_has, 10, 10)

    form.show(target).then(r =>{
        let [ emer_transfer ] = r.formValues
        const emer_big = Math.floor(emer_transfer / 100)
        const ebexport = emer_big * 100
        const emer_small = emer_transfer - ebexport
        const esf = emer_small / 10
        if(emer_has >= 10){
            runcmd(`tellraw "${name}" {"rawtext":[{"translate":"axiscube.msg.emerald.cash_s","with":{"rawtext":[{"text":"${name}"},{"text":"${emer_transfer}"},{"translate":"axiscube.bank.axisbank"},${abstractSTRGbank(target, 'bank_json')}]}}]}`)
            runcmd(`scoreboard players remove "${name}" minecrafter.xyz ${emer_transfer}`)
            playsound('emerald.use', name)
            runcmd(`give "${name}" mcxyz:emerald_big ${emer_big}`)
            runcmd(`give "${name}" mcxyz:emerald_small ${esf}`)
        }else{
            tellraw(`{"rawtext":[{"translate":"axiscube.msg.emerald.cash_d","with":{"rawtext":[{"text":"${name}"},{"text":"${emer_transfer}"},{"translate":"axiscube.bank.axisbank"},${abstractSTRGbank(target, 'bank_json')}]}}]}`)
        }
})
}

function axisbank_transfer(target) {
let name = target.nameTag
    let emer_has = getBalance(name)
    let BankPlayerArray= Array.from(world.getPlayers(),plr=>plr.name)

    const form2 = new ModalFormData();
    form2.dropdown("%axiscube.mode.choice_player", arrayPlayers())
    form2.slider("%axiscube.bank.action.transfer.num", 10, emer_has, 1, 10);
    
    form2.show(target).then(r =>{
        let [name_transfer_num, emer_transfer] = r.formValues
        let name_transfer = BankPlayerArray[name_transfer_num]
        if (emer_has >= 10) {
            runcmd(`scoreboard players remove "${name}" minecrafter.xyz ${emer_transfer}`)
            runcmd(`scoreboard players add "${name_transfer}" minecrafter.xyz ${emer_transfer}`)
            playsound('emerald.use', name_transfer)
            playsound('emerald.use', name)
            tellraw(`{"rawtext":[{"translate":"axiscube.bank.action.transfer.for","with":["${emer_transfer}","${name}"]}]}`, name_transfer)
            runcmd(`title "${name_transfer}" actionbar §b+${emer_transfer}`)
            runcmd(`title "${name}" actionbar §c-${emer_transfer}`)
        } else {
            playsound('random.anvil_break', name)
        }
    })
 }

export function axisbank(target) {
    runcmd('scoreboard objectives add db.bank dummy "AxisBank.js"')
    let name = target.nameTag

    const bank = new ActionFormData()
    .title(`${abstractSTRGbank(target, 'bank_full')}`)
    .body(`Hello, ${name}\n%axiscube.bank.balance: ${getBalance(target)} `)
    .button(`%axiscube.bank.card\n${payment_systems_logo[abstractSTRGbank(target, 'paym')]} *${abstractSTRGbank(target, 'card')} (${payment_systems[abstractSTRGbank(target, 'paym')]})`, 'textures/ui/icons/card.png')
    .button('%axiscube.bank.action.cash_out', 'textures/ui/icon_deals')
    .button('%axiscube.bank.action.transfer', 'textures/ui/trade_icon')
    .button('%axiscube.bank.action.cash_in', 'textures/items/emerald')
    .button('%axiscube.bank.forget_code', 'textures/ui/icons/code.png')

    const be_client = new ModalFormData()
    .title('%axiscube.bank.bank')
    .dropdown(`%axiscube.bank.action.not_client.text\n\n%axiscube.bank.bank`, banks, randomInt(0,2))
    .dropdown(`%axiscube.bank.payment_system`, payment_systems.map(function(_el, num) { return `${payment_systems_logo[num]} ${payment_systems[num]}` }), randomInt(0,2))
    .dropdown(`%options.name`, [name])
    .textField(`%axiscube.bank.set_code`, `${randomInt(1000, 9999)}`, `${randomInt(1000, 9990)}`)

    const bank_setpin = new ModalFormData()
    .title('%axiscube.bank.bank')
    .textField(`%axiscube.bank.set_code`, `${randomInt(1000, 9999)}`, `${randomInt(1000, 9990)}`)

    const bank_card = new ModalFormData()
    .title('%axiscube.bank.bank')
    //.textField(`\nPayment system: ${payment_systems_logo[payment_system_final]} ${payment_systems[payment_system_final]} \n\nCard number`, "0000 0000 0000 0000 0000", `${card_part1} ${card_part2} ${card_part3} ${card_part4}`)
    .textField(`Valid until (MM/YYYY)`, "MM/YYYY", `${new Date().getUTCMonth() + 1}/${new Date().getFullYear()+10}`)
    .textField(`CVC`, `${randomInt(100, 999)}`, `${randomInt(100, 999)}`)

    if (!isNaN(getScore('db.bank', target))){
        bank.show(target).then(async bank2 =>{
            if (bank2.selection == 0) {
                bank_card.show(target).then(bank2card =>{})
            } else if (bank2.selection == 1) {
                axisbank_cash_out(target)
            } else if (bank2.selection == 2) {
                axisbank_transfer(target)
            } else if (bank2.selection == 3) {
                axisbank_deposit(target)
            } else if (bank2.selection == 4) {
                let tst = true
                await showCaptcha(target, function (answer) {tst = answer})
                if (tst) {
                    bank_setpin.show(target).then(bank_setpin2 =>{
                        let [ code ] = bank_setpin2.formValues
                        console.warn(code_pattern.test(code))
                        if (code_pattern.test(code)) {
                            runcmd(`scoreboard players set "${name}" db.bank 1${abstractSTRGbank(target, 'bank')}${abstractSTRGbank(target, 'paym')}${code}${abstractSTRGbank(target, 'card_3rd')}`, true)
                        } else {rawtext('axiscube.bank.incorrect_code', name, 'translate')}
                    })
                }
            }
        })
    } else {
        be_client.show(target).then(cl =>{
            let [ client_bank, client_paym, _, client_code ] = cl.formValues
            if (code_pattern.test(client_code)) {
                rawtext('axiscube.bank.action.now_client.text', name, 'translate')
                runcmd(`scoreboard players set "${name}" db.bank 1${client_bank}${client_paym}${client_code}${randomInt(100, 999)}`, true)
            } else {
                rawtext('axiscube.bank.incorrect_code', name, 'translate')
            }
        })
    }
}

export function buyEmerald(target, item_name, price, cmds) {
    let name = target.nameTag
    let pass = abstractSTRGbank(target, 'pin')
    let captcha_chance = 300
    let captcha_seed = randomInt(1,1000)

    const confirmform = new ModalFormData()
        confirmform.title(`[${abstractSTRGbank(target, 'paym_full')}] %axiscube.title.emerald.buy.title`)
        confirmform.textField(`\n%entity.item.name: §c${item_name}§b (${price})§r\n\n%axiscube.bank.bank: ${abstractSTRGbank(target, 'bank_full')}\n\n%axiscube.bank.card: §g*${abstractSTRGbank(target, 'card')} (${abstractSTRGbank(target, 'paym_full')})§r\n\n%axiscube.bank.enter_code`, `%axiscube.bank.code`)

    const be_client = new ModalFormData()
        .title('%axiscube.bank.bank')
        .dropdown(`%axiscube.bank.action.not_client.text\n\n%axiscube.bank.bank`, banks, randomInt(0,2))
        .dropdown(`%axiscube.bank.payment_system`, payment_systems.map(function(_el, num) { return `${payment_systems_logo[num]} ${payment_systems[num]}` }), randomInt(0,2))
        .dropdown(`%options.name`, [name])
        .textField(`%axiscube.bank.set_code`, `${randomInt(1000, 9999)}`, `${randomInt(1000, 9990)}`)

    if (!isNaN(getScore('db.bank', target))) {
        confirmform.show(target).then(async gg => {
            let [input] = gg.formValues
            if (captcha_seed < captcha_chance) {
                var tst
                await showCaptcha(target, function (answer) {tst = answer})
            } else {
                var tst = true
            }
            if (tst) {
                if (input == pass && price <= getBalance(target))  {
                    playsound('emerald.use', name)
                    for (let i = 0; i != cmds.length; i++){
                        runcmd(cmds[i])
                    }
                addBalance(name, -price)
                tellraw(`{"rawtext":[{"translate":"xyz.minecrafter.msg.emerald.buy","with":{"rawtext":[{"text":"${name}"},{"text":"${item_name}"},{"text":"${price}"},${abstractSTRGbank(target, 'bank_json')}]}}]}`, name)
                } else if (input == pass && price > getBalance(target)) {
                    playsound('emerald.use', name, 1, 0.5)
                    tellraw(`{"rawtext":[{"translate":"xyz.minecrafter.msg.emerald.buy.cancel","with":{"rawtext":[{"text":"${name}"},{"text":"${name}"},{"text":"${item_name}"},{"text":"${price}"},{"score":{"name": "${name}","objective": "minecrafter.xyz"}},${abstractSTRGbank(target, 'bank_json')}]}}]}`, name)
                } else {
                    tellraw(`{"rawtext":[{"translate":"axiscube.bank.r_code"}]}`, name)
                    playsound('random.break', name, 1, 0.5)
                }
            } else {
                playsound('random.break', name, 1, 0.5)
            }
        })
    } else {
        runcmd(`say test`)
        be_client.show(target).then(cl =>{
            let [ client_bank, client_paym, _, client_code ] = cl.formValues
            if (code_pattern.test(client_code)) {
                rawtext('axiscube.bank.action.now_client.text', name, 'translate')
                runcmd(`scoreboard players set "${name}" db.bank 1${client_bank}${client_paym}${client_code}${randomInt(100, 999)}`, true)
            } else {
                rawtext('axiscube.bank.incorrect_code', name, 'translate')
            }
        })
    }
}