import { Dimension, Player, world } from "@minecraft/server";
import {
    ActionFormData,
    ActionFormResponse,
    MessageFormData,
    ModalFormData
  } from "@minecraft/server-ui";
import { death_effects } from "../ui/death_effects";
import {randomInt, runcmd, getScore, hasTag, tellraw, rawtext} from "../AbstractTools.js";
import { pvp_kit1 } from "./pvp_kit1";

if (getScore('debug','minigame') == 14){
world.events.beforeItemUse.subscribe(EventData => {
    if (EventData.item.typeId == "mcxyz:pvp_role_selector") {

        const target = EventData.source
        const player = EventData.source.nameTag
        let gametype = hasTag(target, 'pvp_duel')

        if (gametype) {

            let p1 = "< %gui.none >"
            let p2 = "< %gui.none >"
            let a1 = "unknown"
            let a2 = "unknown"
            for (let i = 0; i != [...world.getPlayers()].length; i++){

                if (hasTag([...world.getPlayers()][i], 'pvpP1')) {
                  p1 = [...world.getPlayers()][i].nameTag
                  a1 = `1`
                } else if (hasTag([...world.getPlayers()][i], 'pvpP2')) {
                    p2 = [...world.getPlayers()][i].nameTag
                    a2 = `2`
                  }
            }

            const pvp_rolesel = new ActionFormData()
            .title("%xyz.minecrafter.bw.select_your_team.name")
            .body("%xyz.minecrafter.pvp.select_your_role")
            .button("%tile.observer.name", "textures/items/ender_eye")
            .button(p1, `textures/ui/icons/skin_picture/${a1}.png`)
            .button("- VS -")
            .button(p2, `textures/ui/icons/skin_picture/${a2}.png`)

            pvp_rolesel.show(EventData.source).then(r => {
                if (r.selection == 0) {
                    runcmd(`tag "${player}" remove pvpP1`)
                    runcmd(`tag "${player}" remove pvpP2`)
                    tellraw(`{"rawtext":[{"translate":"xyz.minecrafter.pvp.spectator","with":{"rawtext":[{"text":"${player}"}]}}]}`, '@a')
                } else if (r.selection == 1) {
                    if (a1 == "unknown") {
                        runcmd(`tag "${player}" add pvpP1`)
                        runcmd(`tag "${player}" remove pvpP2`)
                        tellraw(`{"rawtext":[{"translate":"xyz.minecrafter.pvp.member","with":{"rawtext":[{"text":"${player}"}]}}]}`, '@a')
                    } else {
                        rawtext(`xyz.minecrafter.pvp.too_many_members`, player, 'translate')
                    }
                } else if (r.selection == 2) {
                    tellraw(`{"rawtext":[{"translate":"xyz.minecrafter.pvp.select_your_role"}]}`, player)
                } else if (r.selection == 3) {
                    if (a2 == "unknown") {
                        runcmd(`tag "${player}" remove pvpP1`)
                        runcmd(`tag "${player}" add pvpP2`)
                        tellraw(`{"rawtext":[{"translate":"xyz.minecrafter.pvp.member","with":{"rawtext":[{"text":"${player}"}]}}]}`, '@a')
                    } else {
                        rawtext(`xyz.minecrafter.pvp.too_many_members`, player, 'translate')
                    }
                }
            })
        } else {
            const pvp_rolesel2 = new ActionFormData()
                .title("%xyz.minecrafter.bw.select_your_team.name")
                .button("%tile.observer.name", "textures/items/ender_eye")
                .button("%xyz.minecrafter.pvp.member.button", "textures/items/iron_sword")
            pvp_rolesel2.show(EventData.source).then(r => {
                if (r.selection == 0) {
                    tellraw(`{"rawtext":[{"translate":"xyz.minecrafter.pvp.spectator","with":{"rawtext":[{"text":"${player}"}]}}]}`, '@a')
                    runcmd(`tag "${player}" remove pvp_spawn_player`)
                    runcmd(`tag "${player}" add nab`)
                } else if (r.selection == 1) {
                    tellraw(`{"rawtext":[{"translate":"xyz.minecrafter.pvp.member","with":{"rawtext":[{"text":"${player}"}]}}]}`, '@a')
                    runcmd(`tag "${player}" remove nab`)
                    runcmd(`tag "${player}" add pvp_spawn_player`)
                }
            })
        }
    }
})

world.events.beforeItemUse.subscribe(EventData2 => {
    if (EventData2.item.typeId == "mcxyz:bw_team_selector") {

        const pvp_teamsel = new ActionFormData()
        .title('%xyz.minecrafter.bw.select_your_team.name {"form":"pvp"}')
        .body("%xyz.minecrafter.bw.select_your_team")
        .button("§4%color.red", "textures/ui/icons/team/red.png")
        .button("§1%color.blue", "textures/ui/icons/team/blue.png")
        .button("§2%color.green", "textures/ui/icons/team/green.png")
        .button("§g%color.yellow", "textures/ui/icons/team/yellow.png")

        const name = EventData2.source.nameTag
        const target = EventData2.source

        pvp_teamsel.show(target).then(r => {
            if (r.selection == 0) {
                runcmd(`tag "${name}" add pvp_team_red`);
                runcmd(`tag "${name}" remove pvp_team_blue`);
                runcmd(`tag "${name}" remove pvp_team_green`);
                runcmd(`tag "${name}" remove pvp_team_yellow`);
                tellraw(`{"rawtext":[{"translate":"xyz.minecrafter.teamconnect.red","with":{"rawtext":[{"text":"${name}"}]}}]}`, '@a')
            } else if (r.selection == 1) {
                runcmd(`tag "${name}" remove pvp_team_red`);
                runcmd(`tag "${name}" add pvp_team_blue`);
                runcmd(`tag "${name}" remove pvp_team_green`);
                runcmd(`tag "${name}" remove pvp_team_yellow`);
                tellraw(`{"rawtext":[{"translate":"xyz.minecrafter.teamconnect.blue","with":{"rawtext":[{"text":"${name}"}]}}]}`, '@a')
            } else if (r.selection == 2) {
                runcmd(`tag "${name}" remove pvp_team_red`);
                runcmd(`tag "${name}" remove pvp_team_blue`);
                runcmd(`tag "${name}" add pvp_team_green`);
                runcmd(`tag "${name}" remove pvp_team_yellow`);
                tellraw(`{"rawtext":[{"translate":"xyz.minecrafter.teamconnect.green","with":{"rawtext":[{"text":"${name}"}]}}]}`, '@a')
            } else if (r.selection == 3) {
                runcmd(`tag "${name}" remove pvp_team_red`);
                runcmd(`tag "${name}" remove pvp_team_blue`);
                runcmd(`tag "${name}" remove pvp_team_green`);
                runcmd(`tag "${name}" add pvp_team_yellow`);
                tellraw(`{"rawtext":[{"translate":"xyz.minecrafter.teamconnect.yellow","with":{"rawtext":[{"text":"${name}"}]}}]}`, '@a')
            }
        })
    }
})

world.events.beforeItemUse.subscribe(eventData => {
    if (eventData.item.typeId == "mcxyz:settings") {
        if (hasTag(eventData.source, 'perm_managegame')) { pvp_kit1(eventData.source) } else {rawtext('xyz.minecrafter.noperm', eventData.source.nameTag)}
    }
})
}