import {ActionFormData,ActionFormResponse,MessageFormData,ModalFormData} from "@minecraft/server-ui";
import {Dimension,Player,world} from "@minecraft/server";
import {runcmd, playsound, tellraw, getScore, BoolToNum} from '../AbstractTools.js'

function pvp_kit1 (target){
    const kit1_setting = new ModalFormData()
        .title(`%xyz.minecrafter.menu.kitselection`)
        .dropdown('\n\ue1b9 %itemGroup.name.helmet', ['%item.air.name', '%item.leather_helmet.name', '%item.golden_helmet.name', '%item.chainmail_helmet.name', '%item.iron_helmet.name', '%item.diamond_helmet.name', '%item.netherite_helmet.name', '%item.turtle_helmet.name'], getScore('pvp_kit', 'kit1.armor.head'))
        .dropdown('\n\ue1ba %itemGroup.name.chestplate', ['%item.air.name', '%item.leather_chestplate.name', '%item.golden_chestplate.name', '%item.chainmail_chestplate.name', '%item.iron_chestplate.name', '%item.diamond_chestplate.name', '%item.netherite_chestplate.name'], getScore('pvp_kit', 'kit1.armor.chest'))
        .dropdown('\n\ue1bb %itemGroup.name.leggings', ['%item.air.name', '%item.leather_leggings.name', '%item.golden_leggings.name', '%item.chainmail_leggings.name', '%item.iron_leggings.name', '%item.diamond_leggings.name', '%item.netherite_leggings.name'], getScore('pvp_kit', 'kit1.armor.legs'))
        .dropdown('\n\ue1bc %itemGroup.name.boots', ['%item.air.name', '%item.leather_boots.name', '%item.golden_boots.name', '%item.chainmail_boots.name', '%item.iron_boots.name', '%item.diamond_boots.name', '%item.netherite_boots.name'], getScore('pvp_kit', 'kit1.armor.feet'))
        .dropdown('\n\ue1a8 %itemGroup.name.sword', ['%item.air.name', '%item.wooden_sword.name', '%item.golden_sword.name', '%item.stone_sword.name', '%item.iron_sword.name', '%item.diamond_sword.name', '%item.netherite_sword.name'], getScore('pvp_kit', 'kit1.weapon.sword'))
        .dropdown('\n\ue19a %item.bow.name / %item.crossbow.name', ['%item.air.name', '%item.bow.name', '%item.crossbow.name'], getScore('pvp_kit', 'kit1.weapon.bow.type'))
        .slider('\ue19b %item.arrow.name', 0, 128, 1, getScore('pvp_kit', 'kit1.weapon.bow.arrows'))
        .slider('\ue16a %item.totem.name', 0, 3, 1, getScore('pvp_kit', 'kit1.totem'))
        .slider('\ue12a %item.golden_apple.name', 0, 16, 1, getScore('pvp_kit', 'kit1.golden_apple'))
        .slider('\ue12a %item.appleEnchanted.name', 0, 16, 1, getScore('pvp_kit', 'kit1.notch_apple'))
        .toggle('%item.shield.name', Boolean(getScore('pvp_kit', 'kit1.shield')))

    kit1_setting.show(target).then(kit1 =>{
        let [armor_head, armor_chest, armor_legs, armor_feet, weapon_sword, weapon_bow_type, weapon_bow_arrows, totem, golden_apple, notch_apple, shield] = kit1.formValues
        runcmd(`scoreboard players set "kit1.armor.head" pvp_kit ${armor_head}`)
        runcmd(`scoreboard players set "kit1.armor.chest" pvp_kit ${armor_chest}`)
        runcmd(`scoreboard players set "kit1.armor.legs" pvp_kit ${armor_legs}`)
        runcmd(`scoreboard players set "kit1.armor.feet" pvp_kit ${armor_feet}`)
        runcmd(`scoreboard players set "kit1.weapon.sword" pvp_kit ${weapon_sword}`)
        runcmd(`scoreboard players set "kit1.weapon.bow.type" pvp_kit ${weapon_bow_type}`)
        runcmd(`scoreboard players set "kit1.weapon.bow.arrows" pvp_kit ${weapon_bow_arrows}`)
        runcmd(`scoreboard players set "kit1.totem" pvp_kit ${totem}`)
        runcmd(`scoreboard players set "kit1.golden_apple" pvp_kit ${golden_apple}`)
        runcmd(`scoreboard players set "kit1.notch_apple" pvp_kit ${notch_apple}`)
        runcmd(`scoreboard players set "kit1.shield" pvp_kit ${BoolToNum(shield)}`)
    })
}

function show_pvp_kit1 (target){
    const show_pvp_kit1 = new ModalFormData()
        .title(`%xyz.minecrafter.menu.kitselection`)
        .dropdown('\n\ue1b9 %itemGroup.name.helmet', ['%item.air.name', '%item.leather_helmet.name', '%item.golden_helmet.name', '%item.chainmail_helmet.name', '%item.iron_helmet.name', '%item.diamond_helmet.name', '%item.netherite_helmet.name', '%item.turtle_helmet.name'], getScore('pvp_kit', 'kit1.armor.head'))
        .dropdown('\n\ue1ba %itemGroup.name.chestplate', ['%item.air.name', '%item.leather_chestplate.name', '%item.golden_chestplate.name', '%item.chainmail_chestplate.name', '%item.iron_chestplate.name', '%item.diamond_chestplate.name', '%item.netherite_chestplate.name'], getScore('pvp_kit', 'kit1.armor.chest'))
        .dropdown('\n\ue1bb %itemGroup.name.leggings', ['%item.air.name', '%item.leather_leggings.name', '%item.golden_leggings.name', '%item.chainmail_leggings.name', '%item.iron_leggings.name', '%item.diamond_leggings.name', '%item.netherite_leggings.name'], getScore('pvp_kit', 'kit1.armor.legs'))
        .dropdown('\n\ue1bc %itemGroup.name.boots', ['%item.air.name', '%item.leather_boots.name', '%item.golden_boots.name', '%item.chainmail_boots.name', '%item.iron_boots.name', '%item.diamond_boots.name', '%item.netherite_boots.name'], getScore('pvp_kit', 'kit1.armor.feet'))
        .dropdown('\n\ue1a8 %itemGroup.name.sword', ['%item.air.name', '%item.wooden_sword.name', '%item.golden_sword.name', '%item.stone_sword.name', '%item.iron_sword.name', '%item.diamond_sword.name', '%item.netherite_sword.name'], getScore('pvp_kit', 'kit1.weapon.sword'))
        .dropdown('\n\ue19a %item.bow.name / %item.crossbow.name', ['%item.air.name', '%item.bow.name', '%item.crossbow.name'], getScore('pvp_kit', 'kit1.weapon.bow.type'))
        .slider('\ue19b %item.arrow.name', 0, 128, 1, getScore('pvp_kit', 'kit1.weapon.bow.arrows'))
        .slider('\ue16a %item.totem.name', 0, 3, 1, getScore('pvp_kit', 'kit1.totem'))
        .slider('\ue12a %item.golden_apple.name', 0, 16, 1, getScore('pvp_kit', 'kit1.golden_apple'))
        .slider('\ue12a %item.appleEnchanted.name', 0, 16, 1, getScore('pvp_kit', 'kit1.notch_apple'))
        .toggle('%item.shield.name', Boolean(getScore('pvp_kit', 'kit1.shield')))

        show_pvp_kit1.show(target).then(kit1 =>{})
}

export { pvp_kit1 }