import {
  ActionFormData,
  ActionFormResponse,
  MessageFormData,
  ModalFormData
} from "@minecraft/server-ui";
import { world } from "@minecraft/server";
import { axisbank } from "./AxisBank/index.js";
import { menu_donate, menu_info } from "./ui/info.js";
import { settings_form } from "./ui/settings.js";
import { gameselect_form } from "./ui/gameselect";


 world.events.beforeItemUse.subscribe(eventData => {
    if(eventData.item.typeId == "mcxyz:game_selector"){
        gameselect_form(eventData.source)
}})

world.events.beforeItemUse.subscribe(eventData => {
  if(eventData.item.typeId == "mcxyz:menu"){
    const menu_mainpage = new ActionFormData()
    .title("%feed.return")
    .body("§4X§2Y§1Z §4M§6I§eN§aI§bG§3A§aM§5E§dS§r by §aAxis§bCube")
    .button("%xyz.minecrafter.button.selectgame", "textures/ui/icons/players.png")
    .button("%manifestvalidation.info", "textures/ui/icons/search2.png")     
    .button("%menu.settings", "textures/items/settings")
    .button("%axiscube.bank.bank", "textures/items/emerald")
    .button("%xyz.minecrafter.button.donate", "textures/ui/icons/donate.png")
    const ui_player = eventData.source.nameTag
    const ui_target = eventData.source
    
    menu_mainpage.show(ui_target).then(r => {
      if (r.selection == 0) {
        gameselect_form(ui_target)
      }
      else if (r.selection == 1) {
          menu_info(ui_target)
      }
      else if (r.selection == 2) {
          settings_form(ui_target);
      }
      else if (r.selection == 3) {
          try{axisbank(ui_target)}catch(error){console.error(error)}
      }
      else if (r.selection == 4) {
          menu_donate(ui_target)
      }
    })
  }
})