import {ActionFormData,ActionFormResponse,MessageFormData,ModalFormData} from "@minecraft/server-ui"
import {Dimension,Player,world} from "@minecraft/server"
import {runcmd,runcmd_at, playsound, tellraw, hasTag, textTag} from '../AbstractTools.js'
import { buyEmerald } from "../AxisBank/index.js"
import { iRUN } from "../AbstractChat/cmd/emojis.js"
import { death_effects } from "../ui/death_effects"


world.events.beforeItemUse.subscribe(event0 =>{
  const name = event0.source.nameTag
  const target = event0.source

  const main = new ActionFormData()
    .title('%xyz.minecrafter.menu.donate.cosmetic.text')
    .button(`%xyz.minecrafter.particles_menu.name`, "textures/ui/icons/particles.png")
    .button(`%key.mobEffects`, "textures/ui/jump_boost_effect")
    .button(`%xyz.minecrafter.menu.donate.cosmetic.reactions`, "textures/ui/icons/reacts.png")

  const effects = new ModalFormData()
    .title(`%key.mobEffects`)
    .slider('\n§r'+`\ue1ef %potion.moveSpeed`,0,5,1,0)
    .slider('\n§r'+`\ue1ee %potion.jump`,0,5,1,0)

  const particles = new ActionFormData()
    .title('%xyz.minecrafter.menu.donate.cosmetic.text')
    .body(`%xyz.minecrafter.menu.donate.cosmetic.particle.text`)
    .button(`%controls.reset`, 'textures/blocks/barrier')
    .button(`${textTag(target, 'cosmetic_particle4', '\ue1c9', '')}${textTag(target, 'cosmetic_particle4buy', '', '\ue12f')} %tile.flowing_lava.name ${textTag(target, 'cosmetic_particle4buy', '', '(300)')}`, 'textures/blocks/lava_placeholder')
    .button(`${textTag(target, 'cosmetic_particle1', '\ue1c9', '')}${textTag(target, 'cosmetic_particle1buy', '', '\ue12f')} %color.gold ${textTag(target, 'cosmetic_particle1buy', '', '(300)')}`, 'textures/blocks/gold_block')
    .button(`${textTag(target, 'cosmetic_particle2', '\ue1c9', '')}${textTag(target, 'cosmetic_particle2buy', '', '\ue12f')} %item.emerald.name ${textTag(target, 'cosmetic_particle2buy', '', '(300)')}`, 'textures/blocks/emerald_block')
    .button(`${textTag(target, 'cosmetic_particle3', '\ue1c9', '')}${textTag(target, 'cosmetic_particle3buy', '', '\ue12f')} %item.diamond.name ${textTag(target, 'cosmetic_particle3buy', '', '(300)')}`, 'textures/blocks/diamond_block')



  if(event0.item.typeId == 'mcxyz:cosmetic'){
    function formsteps(fs, target){
      if(fs == 'main'){
        main.show(target).then(s =>{
          if(s.selection == 0){
            playsound('block.end_portal_frame.fill',name)
            formsteps('main_particles', target);
          }
          else if(s.selection == 1){
            playsound('block.end_portal_frame.fill',name)
            formsteps('main_effects', target);
          }
          else if(s.selection == 2){
            playsound('block.end_portal_frame.fill',name)
            formsteps('main_reactions', target);
          }
        })
      }
      else if(fs == 'main_particles'){
        particles.show(target).then(s =>{
          if(s.selection == 0){
            runcmd(`tag "${name}" remove cosmetic_particle1`)
            runcmd(`tag "${name}" remove cosmetic_particle2`)
            runcmd(`tag "${name}" remove cosmetic_particle3`)
            runcmd(`tag "${name}" remove cosmetic_particle4`)
            runcmd(`tag "${name}" remove cosmetic_particle5`)
            tellraw('{\"rawtext\":[{\"translate\":\"xyz.minecrafter.msg.menu.settings.reset_generic\"}]}',name,'@s')
            playsound('block.end_portal_frame.fill',name)
          }
          else if(s.selection == 1){
            if(target.getTags().indexOf('cosmetic_particle4buy') == -1){
              buyEmerald(target, `%tile.flowing_lava.name particle`, 300, [`tag "${name}" add cosmetic_particle4buy`])
              //try{buy_item(name, 300, 'cosmetic_particle4buy', 'Lava', target)}catch(error){console.warn(error)}
            }
            else{
              runcmd_at(name,'tag @s[tag=cosmetic_particle4buy] add cosmetic_particle4')
              runcmd_at(name,'tag @s[tag=cosmetic_particle4buy] remove cosmetic_particle1')
              runcmd_at(name,'tag @s[tag=cosmetic_particle4buy] remove cosmetic_particle2')
              runcmd_at(name,'tag @s[tag=cosmetic_particle4buy] remove cosmetic_particle3')
              runcmd_at(name,'tag @s[tag=cosmetic_particle4buy] remove cosmetic_particle5')
              tellraw('{\"rawtext\":[{\"translate\":\"hBui.TabBar.selected\"},{\"text\":\":  \"},{\"translate\":\"tile.flowing_lava.name\"}]}',name,'@s[tag=cosmetic_particle4buy]')
              playsound('block.end_portal_frame.fill',name)
            }

          }
          else if(s.selection == 2){
            if(target.getTags().indexOf('cosmetic_particle1buy') == -1){
              buyEmerald(target, `%tile.gold_block.name particle`, 300, [`tag "${name}" add cosmetic_particle1buy`])
              //try{buy_item(name, 300, 'cosmetic_particle1buy', `%color.gold`, target)}catch(error){console.warn(error)}
            }
            else{
              runcmd_at(name,'tag @s[tag=cosmetic_particle1buy] remove cosmetic_particle4')
              runcmd_at(name,'tag @s[tag=cosmetic_particle1buy] add cosmetic_particle1')
              runcmd_at(name,'tag @s[tag=cosmetic_particle1buy] remove cosmetic_particle2')
              runcmd_at(name,'tag @s[tag=cosmetic_particle1buy] remove cosmetic_particle3')
              runcmd_at(name,'tag @s[tag=cosmetic_particle1buy] remove cosmetic_particle5')
              tellraw('{\"rawtext\":[{\"translate\":\"hBui.TabBar.selected\"},{\"text\":\":  \"},{\"translate\":\"color.gold\"}]}', name,'@s[tag=cosmetic_particle1buy]')
              playsound('block.end_portal_frame.fill',name)
            }
          }
          else if(s.selection == 3){
            if(target.getTags().indexOf('cosmetic_particle2buy') == -1){
              buyEmerald(target, `%tile.emerald_block.name particle`, 300, [`tag "${name}" add cosmetic_particle2buy`])
              //try{buy_item(name, 300, 'cosmetic_particle2buy', `%item.emerald.name`, target)}catch(error){console.warn(error)}
            }
            else{
              runcmd_at(name,'tag @s[tag=cosmetic_particle2buy] remove cosmetic_particle4')
              runcmd_at(name,'tag @s[tag=cosmetic_particle2buy] remove cosmetic_particle1')
              runcmd_at(name,'tag @s[tag=cosmetic_particle2buy] add cosmetic_particle2')
              runcmd_at(name,'tag @s[tag=cosmetic_particle2buy] remove cosmetic_particle3')
              runcmd_at(name,'tag @s[tag=cosmetic_particle2buy] remove cosmetic_particle5')
              tellraw('{\"rawtext\":[{\"translate\":\"hBui.TabBar.selected\"},{\"text\":\":  \"},{\"translate\":\"item.emerald.name\"}]}', name,'@s[tag=cosmetic_particle2buy]')
              playsound('block.end_portal_frame.fill',name)
            }
          }
          else if(s.selection == 4){
            if(target.getTags().indexOf('cosmetic_particle3buy') == -1){
              buyEmerald(target, `%tile.diamond_block.name particle`, 300, [`tag "${name}" add cosmetic_particle3buy`])
             // try{buy_item(name, 300, 'cosmetic_particle3buy', `%item.diamond.name`, target)}catch(error){console.warn(error)}
            }
            else{
                runcmd_at(name,'tag @s[tag=cosmetic_particle3buy] remove cosmetic_particle4')
                runcmd_at(name,'tag @s[tag=cosmetic_particle3buy] remove cosmetic_particle1')
                runcmd_at(name,'tag @s[tag=cosmetic_particle3buy] remove cosmetic_particle2')
                runcmd_at(name,'tag @s[tag=cosmetic_particle3buy] add cosmetic_particle3')
                runcmd_at(name,'tag @s[tag=cosmetic_particle3buy] remove cosmetic_particle5')
              tellraw('{\"rawtext\":[{\"translate\":\"hBui.TabBar.selected\"},{\"text\":\":  \"},{\"translate\":\"item.diamond.name\"}]}",', name,'@s[tag=cosmetic_particle2buy]')
              playsound('block.end_portal_frame.fill',name)
            }
          }
        })

      }
      else if(fs == 'main_effects'){
        const _effects = effects.show(target).then(s =>{
          if (s.isCanceled) return
            let [ e_speed , e_jump] = s.formValues
            const speed_array = [0,1,2,3,4,5]
            const jump_array = [0,1,2,3,4,5]

            var cloned_spd = speed_array.slice()
            var cloned_jmp = jump_array.slice()
            cloned_spd.splice(e_speed,1)
            cloned_jmp.splice(e_jump,1)
            runcmd(`tag "${name}" add lobby_speed_`+e_speed)
            runcmd(`tag "${name}" remove lobby_speed_`+cloned_spd[0])
            runcmd(`tag "${name}" remove lobby_speed_`+cloned_spd[1])
            runcmd(`tag "${name}" remove lobby_speed_`+cloned_spd[2])
            runcmd(`tag "${name}" remove lobby_speed_`+cloned_spd[3])
            runcmd(`tag "${name}" remove lobby_speed_`+cloned_spd[4])

            runcmd(`tag "${name}" add lobby_jump_`+e_jump)
            runcmd(`tag "${name}" remove lobby_jump_`+cloned_jmp[0])
            runcmd(`tag "${name}" remove lobby_jump_`+cloned_jmp[1])
            runcmd(`tag "${name}" remove lobby_jump_`+cloned_jmp[2])
            runcmd(`tag "${name}" remove lobby_jump_`+cloned_jmp[3])
            runcmd(`tag "${name}" remove lobby_jump_`+cloned_jmp[4])
            playsound('block.end_portal_frame.fill',name)
          }).catch(e =>{})
        }
      else if(fs == 'main_reactions'){
        iRUN(target, 'null$')
        }
    }
    formsteps('main', target)
  }
})

