import {ActionFormData,ActionFormResponse,MessageFormData,ModalFormData} from "@minecraft/server-ui";
import {Dimension,Player,world} from "@minecraft/server";
import {runcmd,runcmd_at, playsound, tellraw, textTag, hasTag} from '../AbstractTools.js'
import {buyEmerald} from '../AxisBank/index.js'

export function death_effects(target){
    let name = target.nameTag
    const settings_my_gset_pr = new ActionFormData()
        .title("%menu.settings")
        .body("%xyz.minecrafter.particles_menu.description")
        .button("%gui.default", "textures/ui/icons/particles.png")
        .button(`${textTag(target, 'particle.type_1', '\ue1c9', '')}${textTag(target, 'particle.type_1.buy', '', '\ue12f')} %item.banner.skull.white ${textTag(target, 'particle.type_1.buy', '', '(450)')}`, "textures/ui/icons/particles/white_skull.png")
        .button(`${textTag(target, 'particle.type_2', '\ue1c9', '')}${textTag(target, 'particle.type_2.buy', '', '\ue12f')} %item.banner.skull.red ${textTag(target, 'particle.type_2.buy', '', '(450)')}`, "textures/ui/icons/particles/red_skull.png")
        .button(`${textTag(target, 'particle.type_3', '\ue1c9', '')}${textTag(target, 'particle.type_3.buy', '', '\ue12f')} Bubbles ${textTag(target, 'particle.type_3.buy', '', '(300)')}`, "textures/ui/icons/particles/bubbles.png")
        .button(`${textTag(target, 'particle.type_4', '\ue1c9', '')}${textTag(target, 'particle.type_4.buy', '', '\ue12f')} §4B§6u§gb§2b§bl§1e§ds §8${textTag(target, 'particle.type_4.buy', '', '(500)')}`, "textures/ui/icons/particles/rainbow_bubbles.png")
        .button(`${textTag(target, 'particle.type_5', '\ue1c9', '')}${textTag(target, 'particle.type_5.buy', '', '\ue12f')} %item.fireworksCharge.flicker ${textTag(target, 'particle.type_5.buy', '', '(500)')}`, "textures/ui/icons/particles/mertz.png")
        .button(`${textTag(target, 'particle.type_6', '\ue1c9', '')}${textTag(target, 'particle.type_6.buy', '', '\ue12f')} %howtoplay.redstone ${textTag(target, 'particle.type_6.buy', '', '(400)')}\n§lNOT BLOOD!!!§o (blood)`, "textures/blocks/redstone_block")
    settings_my_gset_pr.show(target).then(smgp => {
        if(smgp.selection == 0){
            runcmd(`tag "${name}" remove particle.type_1`)
            runcmd(`tag "${name}" remove particle.type_2`)
            runcmd(`tag "${name}" remove particle.type_3`)
            runcmd(`tag "${name}" remove particle.type_4`)
            runcmd(`tag "${name}" remove particle.type_5`)
            runcmd(`tag "${name}" remove particle.type_6`)
            tellraw('{\"rawtext\":[{\"translate\":\"xyz.minecrafter.msg.menu.settings.reset_generic\"}]}',name,'@s')
            playsound('block.end_portal_frame.fill',name)
        } else if(smgp.selection == 1){
            if(!hasTag(target, 'particle.type_1.buy')){
              buyEmerald(target, `%item.banner.skull.white`, 450, [`tag "${name}" add particle.type_1.buy`])
                //buy_item(name, 450, 'particle.type_1.buy', `%item.banner.skull.white` , target)}catch(error){console.warn(error)}
              }
              else{
                runcmd_at(name,'tag @s[tag=particle.type_1] add particle.type_1')
                runcmd_at(name,'tag @s[tag=particle.type_1] remove particle.type_2')
                runcmd_at(name,'tag @s[tag=particle.type_1] remove particle.type_3')
                runcmd_at(name,'tag @s[tag=particle.type_1] remove particle.type_4')
                runcmd_at(name,'tag @s[tag=particle.type_1] remove particle.type_5')
                runcmd_at(name,'tag @s[tag=particle.type_1] remove particle.type_6')
                tellraw('{"rawtext":[{"text": "},{"translate":"item.banner.skull.white"}]}',name)
                playsound('block.end_portal_frame.fill',name)
              }

        }
        else if(smgp.selection == 2){
            if(!hasTag(target, 'particle.type_2.buy')){
                buyEmerald(target, `%item.banner.skull.red`, 450, [`tag "${name}" add particle.type_2.buy`])
                //buy_item(name, 450, 'particle.type_2.buy', `%item.banner.skull.red` , target)}catch(error){console.warn(error)}
              }
              else{
                runcmd_at(name,'tag @s remove particle.type_1')
                runcmd_at(name,'tag @s add particle.type_2')
                runcmd_at(name,'tag @s remove particle.type_3')
                runcmd_at(name,'tag @s remove particle.type_4')
                runcmd_at(name,'tag @s remove particle.type_5')
                runcmd_at(name,'tag @s remove particle.type_6')
                tellraw('{"rawtext":[{"text":" "},{"translate":"item.banner.skull.red"}]}',name)
                playsound('block.end_portal_frame.fill',name)
              }

        }
        else if(smgp.selection == 3){
            if(!hasTag(target, 'particle.type_3.buy')){
              buyEmerald(target, `Bubbles`, 300, [`tag "${name}" add particle.type_3.buy`])
                //buy_item(name, 300, 'particle.type_3.buy', `Bubbles` , target)}catch(error){console.warn(error)}
              }
              else{
                runcmd_at(name,'tag @s remove particle.type_1')
                runcmd_at(name,'tag @s remove particle.type_2')
                runcmd_at(name,'tag @s add particle.type_3')
                runcmd_at(name,'tag @s remove particle.type_4')
                runcmd_at(name,'tag @s remove particle.type_5')
                runcmd_at(name,'tag @s remove particle.type_6')
                tellraw('{"rawtext":[{"text":" "},{"translate":"Bubbles"}]}',name)
                playsound('block.end_portal_frame.fill',name)
              }

        }
        else if(smgp.selection == 4){
            if(!hasTag(target, 'particle.type_4.buy')){
              buyEmerald(target, `§4B§6u§gb§2b§bl§1e§ds§r`, 500, [`tag "${name}" add particle.type_4.buy`])
              } else {
                runcmd_at(name,'tag @s remove particle.type_1')
                runcmd_at(name,'tag @s remove particle.type_2')
                runcmd_at(name,'tag @s remove particle.type_3')
                runcmd_at(name,'tag @s add particle.type_4')
                runcmd_at(name,'tag @s remove particle.type_5')
                runcmd_at(name,'tag @s remove particle.type_6')
                tellraw('{"text":" "},{"translate":"§4B§6u§gb§2b§bl§1e§ds"}]}',name,'@s[tag=particle.type_4.buy]')
                playsound('block.end_portal_frame.fill',name)
            }
        }
        else if(smgp.selection == 5){
            if(!hasTag(target, 'particle.type_5.buy')){
              buyEmerald(target, `%item.fireworksCharge.flicker`, 500, [`tag "${name}" add particle.type_5.buy`])
              //  buy_item(name, 500, 'particle.type_5.buy', `%item.fireworksCharge.flicker` , target)}catch(error){console.warn(error)}
              }
              else{
                runcmd_at(name,'tag @s remove particle.type_1')
                runcmd_at(name,'tag @s remove particle.type_2')
                runcmd_at(name,'tag @s remove particle.type_3')
                runcmd_at(name,'tag @s remove particle.type_4')
                runcmd_at(name,'tag @s add particle.type_5')
                runcmd_at(name,'tag @s remove particle.type_6')
                tellraw('{"rawtext":[{"text":" "},{"translate":"item.fireworksCharge.flicker"}]}',name,'@s[tag=particle.type_5.buy]')
                playsound('block.end_portal_frame.fill',name)
              }

        }
        else if(smgp.selection == 6){
            if(!hasTag(target, 'particle.type_6.buy')){
                buyEmerald(target, `%howtoplay.redstone`, 400, [`tag "${name}" add particle.type_6.buy`])
              }
              else{
                runcmd_at(name,'tag @s remove particle.type_1')
                runcmd_at(name,'tag @s remove particle.type_2')
                runcmd_at(name,'tag @s remove particle.type_3')
                runcmd_at(name,'tag @s remove particle.type_4')
                runcmd_at(name,'tag @s remove particle.type_5')
                runcmd_at(name,'tag @s add particle.type_6')
                tellraw('{"rawtext":[{"text":" "},{"translate":"howtoplay.redstone"}]}',name,'@s[tag=particle.type_6.buy]')
                playsound('block.end_portal_frame.fill',name)
              }

        }

      })
//particle.type_1 - particle mcxyz:skulls_white ~~~
//particle.type_2 - particle mcxyz:skulls_red ~~~
//particle.type_3 - particle minecraft:example_bounce ~~~
//particle.type_4 - particle minecraft:example_colorcurve ~~~
//particle.type_5 - particle minecraft:example_combocurve ~~~
//particle.type_6 - particle mcxyz:blockcrack-redstone ~~~


}