import {
    ActionFormData,
    ActionFormResponse,
    MessageFormData,
    ModalFormData
  } from "@minecraft/server-ui";
  import { Dimension, Player, world } from "@minecraft/server";
  import {runcmd, getScore, hasTag, textTag, tellraw, arrayPlayers, rawtext} from '../AbstractTools.js'

function runPermFunction(target, fname){
    let name = target.nameTag
    if (hasTag(target, 'perm_startgame')){
        runcmd(`execute as @a[name="${name}"] at @a[name="${name}"] run function ${fname}`)
    } else {
        runcmd(`tellraw "${name}" {"rawtext":[{"text":"§c"},{"translate":"xyz.minecrafter.noperm"}]}`)
    }
}
function runPermCommand(target, cmd, need_log = false){
    let name = target.nameTag
    if (hasTag(target, 'perm_startgame')){
        runcmd(`execute as @a[name="${name}"] at @a[name="${name}"] run ${cmd}`, need_log)
    } else {
        runcmd(`tellraw "${name}" {"rawtext":[{"text":"§c"},{"translate":"xyz.minecrafter.noperm"}]}`)
    }
}

function gameselect_form(target){

      let name = target.nameTag

      const fwarn_pl = new MessageFormData()
        .title('\ue1f8 %gui.error')
        .body('§c%ru.mcxyz.desription.warn.noplayers')
        .button1('%gui.continue')
        .button2('%gui.cancel')

      const fwarn_perms = new MessageFormData()
        .title('\ue1f8 %gui.error')
        .body('§c%ru.mcxyz.desription.warn.no_op')
        .button1('%gui.yes')
        .button2('%gui.cancel')

      const menu_gamesel = new ActionFormData()
        .title("%xyz.minecrafter.button.selectgame")
        .body("%axiscube.menu.gamesel")
        .button("%axiscube.menu.gamesel.pl1", "textures/ui/icons/1pl.png")
        .button("%axiscube.menu.gamesel.pl2", "textures/ui/icons/2pl.png")

      const f2pl = new ActionFormData()
        .title("%xyz.minecrafter.button.selectgame")
        .body("%axiscube.menu.gamesel.pl2")
        .button("MicroGames §4N§2E§1W§3!", "textures/ui/icons/2pl.png")
        .button("SkyWars: LuckyMode §4N§2E§1W§3!", "textures/ui/icons/render/pvp.png")
        .button("FlagWars", "textures/ui/icons/render/flagwars.png")
        .button("DeathRun", "textures/ui/icons/render/deathrun.png")
        .button("SkyWars", "textures/ui/icons/render/pvp.png")
        .button("BlockParty", "textures/ui/icons/render/blockparty.png")
        .button("PVP Games", "textures/ui/icons/render/pvp.png")
        .button("%xyz.minecrafter.mg.hg", "textures/ui/icons/render/hg.png")
        .button("%xyz.minecrafter.mg.spl", "textures/ui/icons/render/spleef.png")
        .button("%xyz.minecrafter.mg.pl", "textures/ui/icons/render/lava_floor.png")
        .button("BedWars", "textures/ui/icons/render/bw.png")
        

      const f1pl = new ActionFormData()
        .title("%xyz.minecrafter.button.selectgame")
        .body("%axiscube.menu.gamesel.pl1")
        .button("%xyz.minecrafter.mg.mn", "textures/ui/icons/render/minefield.png")
        .button("%xyz.minecrafter.mg.prk", "textures/ui/icons/render/prk.png")
        .button("%xyz.minecrafter.mg.chick", "textures/ui/icons/render/chicken.png")
        .button("%xyz.minecrafter.mg.dropper", "textures/ui/icons/render/dropper.png")
        .button("§3[Squid§5Game] §8%tile.glass.name", 'textures/blocks/glass')
        .button("§3[Squid§5Game] §8%xyz.minecrafter.mg.squidgame.red_yellow_green_light", "textures/blocks/glass_red")
        .button("TNT RUN", "textures/blocks/tnt_side")


  function pvp_display(){
    if (Array.from(world.getPlayers()).length >= 2){
      return `§c${Array.from(world.getPlayers(),plr=>plr.name)[1]}§0vs§9${Array.from(world.getPlayers(),plr=>plr.name)[0]}`
    } else {
      return '§cPLAYER§0vs§9PLAYER'
    }
  }

  function pvp_display2(){
    if (Array.from(world.getPlayers()).length >= 3){
      return `§c${Array.from(world.getPlayers(),plr=>plr.name)[1]}§0vs§9${Array.from(world.getPlayers(),plr=>plr.name)[0]}§0vs§2${Array.from(world.getPlayers(),plr=>plr.name)[2]}`
    } else {
      return '§cPLAYER§0vs§9PLAYER§0vs§2PLAYER'
    }
  }

  const f2pl_pvp = new ActionFormData()
  .title("PVP GAMES")
  .body("Games")
  .button(`%xyz.minecrafter.mg.duel\n${pvp_display()}`, 'textures/ui/icons/render/pvp.png')
  .button('PVP: Teams\n§l§cTEAM§rvs§l§9TEAM§rvs§l§gTEAM§rvs§l§2TEAM', 'textures/ui/icons/render/pvp.png')
  .button(`PVP: Survival\n${pvp_display2()}`, 'textures/ui/icons/render/pvp.png')
  
  const f2pl_pvp_duel_sel = new ActionFormData()
  .title("%xyz.minecrafter.mg.duel")
  .button("%axiscube.gmsel.duel.op_choice")
  .button("%axiscube.gmsel.duel.players_choice")


  let pvp_players = arrayPlayers()
  const f2pl_pvp_duel = new ModalFormData()
  .title("%xyz.minecrafter.mg.duel")
  .dropdown("%axiscube.mode.choice_player (1)", pvp_players)
  .dropdown("VS\n\n%axiscube.mode.choice_player (2)", pvp_players, 1)

  const f2pl_deathrun_start = new ActionFormData()
  .title("DeathRun")
  .body("GameModeType=")
  .button('%axiscube.mode.rand_player', 'textures/ui/icons/random.png')
  .button('%axiscube.mode.choice_player', 'textures/ui/icons/particles/red_skull.png')

  const f2pl_deathrun_dsel = new ModalFormData()
  .title("DeathRun")
  .dropdown("%axiscube.mode.choice_player", arrayPlayers())

  const f1pl_mn_start = new ActionFormData()
  .title("%xyz.minecrafter.mg.mn")
  .button('%ru.mcxyz.menu.arena.classic', 'textures/ui/icons/mg/mn_1.png')
  .button('%ru.mcxyz.menu.arena.clifs', 'textures/ui/icons/mg/mn_2.png')
  .button('%ru.mcxyz.menu.arena.town', 'textures/ui/icons/mg/mn_3.png')

  const f1pl_mn_start2 = new ActionFormData()
  .title("%xyz.minecrafter.menu.select.difficulty")
  .body("%ru.mcxyz.menu.speed_start.about")
  .button('%ru.mcxyz.menu.speed_start', 'textures/ui/icons/back.png')
  .button('%options.difficulty.easy', 'textures/ui/icons/mg/mn_easy.png')
  .button('%options.difficulty.normal', 'textures/ui/icons/mg/mn_norm.png')
  .button('%options.difficulty.hard', 'textures/ui/icons/mg/mn_hard_o.png')
  

  const f1pl_prk_start = new ActionFormData()
  .title('%xyz.minecrafter.mg.prk')
  .button('%xyz.minecratfer.parkour.arena.mansion', 'textures/ui/icons/mg/prk_1.png')
  .button('%xyz.minecratfer.parkour.arena.egypt', 'textures/ui/icons/mg/prk_2.png')
  .button('%xyz.minecratfer.parkour.arena.japan', 'textures/ui/icons/mg/prk_3.png')
  .button('%axiscube.parkour.arena.sweets', 'textures/ui/icons/mg/prk_4.png')

  const f1pl_pl_start = new ModalFormData()
  .title("%xyz.minecrafter.mg.pl")
  .dropdown("%xyz.minecrafter.mg.pl.description_ingame\n\n%stat.blocksButton", ["%tile.glass.name", "%tile.hardened_clay.name", "%item.brick.name"], 2)

  const f1pl_gl_start = new ModalFormData()
  .title("%tile.glass.name")
  .slider("%xyz.minecrafter.mg.glass.description_ingame\n\n %xyz.minecrafter.hp_count (%gui.default: 5)", 0, 30, 1, getScore('settings', 'glass_hp'))


  function game_description(gds_cmd, gds_name, gds_description){
    const form_game_description = new ActionFormData()
        .title(gds_name)
        .body(`\n${gds_description}\n`)
        .button(`${textTag(target, 'perm_startgame', '', '\ue12f ')}%menu.start${textTag(target, 'perm_startgame', '', '\n§c%xyz.minecrafter.noperm')}`, 'textures/items/gamepad.png')
        
        form_game_description.show(target).then(gmd => {
          if (gmd.selection == 0) {
            if (hasTag(target, 'perm_startgame')) {
            runcmd(`execute as @a[name="${name}",tag=perm_startgame] at @a[name="${name}",tag=perm_startgame] run ${gds_cmd}`)
          } else {
            runcmd(`tellraw @a[name="${name}"] {"rawtext":[{"text":"§c"},{"translate":"xyz.minecrafter.noperm"}]}`)
          }
          }
        })
  }

        function form_2players(){
          f2pl.show(target).then(gm2 => {
            if (gm2.selection == 2) {
              game_description(`function zz_games/flagw/start`, 'FlagWars', '%xyz.minecrafter.mg.flagw.description')
            } else if (gm2.selection == 3) {
              f2pl_deathrun_start.show(target).then(dr => {
                    if(dr.selection == 0){
                      runcmd(`tag @a remove dead`)
                      runcmd('scoreboard players set death_random settings 0')
                      runPermFunction(target, 'zz_games/death_run/start')
                    }
                    else if(dr.selection == 1){
                      f2pl_deathrun_dsel.show(target).then(dr => {
                            let [ vzatka ] = dr.formValues
                            runcmd(`tag @a remove dead`)
                            if (Array.from(world.getPlayers()).length >= 2) {
                                runcmd('scoreboard players set death_random settings 1')
                                runcmd(`tag "${Array.from(world.getPlayers(),plr=>plr.name)[vzatka]}" add dead`)
                            }
                            runPermFunction(target, 'zz_games/death_run/start')
                    })}
                  })
            } else if (gm2.selection == 4) {
                runcmd(`scoreboard players set sw_mode debug 1`)
              game_description(`function zz_games/sw/start`, 'SkyWars', '%xyz.minecrafter.mg.sw.description')
            } else if (gm2.selection == 5) {
              game_description(`function zz_games/blockparty/start`, 'BlockParty', '%xyz.minecrafter.mg.blockprty.description')
            } else if (gm2.selection == 6) {
              f2pl_pvp.show(target).then(pvp => {
                if (pvp.selection == 0) {
                    f2pl_pvp_duel_sel.show(target).then(gg => {
                        if (gg.selection == 0) {
                            f2pl_pvp_duel.show(target).then(gg => {
                                let [duello1, duello2] = gg.formValues
                                if (duello1 == duello2 && duello1 != undefined) {
                                    tellraw('{"rawtext":[{"text":"§cArray.from(world.getPlayers(),plr=>plr.name)[0] == Array.from(world.getPlayers(),plr=>plr.name)[1]"}]}', name)
                                } else if (duello1 != undefined && duello2 != undefined) {
                                    runPermCommand(target, `scoreboard players set pvp_loc1 debug 2`, true)
                                    runPermCommand(target, `tag @a remove pvpP1`, true)
                                    runPermCommand(target, `tag @a remove pvpP2`, true)
                                    duello1 = Array.from(world.getPlayers(),plr=>plr.name)[duello1]
                                    duello2 = Array.from(world.getPlayers(),plr=>plr.name)[duello2]
                                    runPermCommand(target, `tag "${duello1}" add pvpP1`, true)
                                    runPermCommand(target, `tag "${duello2}" add pvpP2`, true)
                                    runPermFunction(target, 'zz_games/pvp/start/solo', true)
                                }
                            })
                        } else if (gg.selection == 1) {
                            runPermCommand(target, `tag @a remove pvpP1`)
                            runPermCommand(target, `tag @a remove pvpP2`)
                            runPermCommand(target, `scoreboard players set pvp_loc1 debug 2`)
                            runPermFunction(target, 'zz_games/pvp/start/solo_democracy')
                        }
                    })
                } else if (pvp.selection == 1) {
                  runPermFunction(target, 'zz_games/pvp/start/team')
                } else if (pvp.selection == 2) {
                  runPermFunction(target, 'zz_games/pvp/start/survival')
                }
              })
            } else if (gm2.selection == 7) {
              game_description(`function zz_games/hg/start`, 'xyz.minecrafter.mg.hg', '%xyz.minecrafter.mg.hg.description')
            } else if (gm2.selection == 8) {
              game_description(`function zz_games/spl/start`, 'xyz.minecrafter.mg.spl', '%xyz.minecrafter.mg.spl.description')
            } else if (gm2.selection == 9) {
              f1pl_pl_start.show(target).then(pl =>{
                    let [ pl_floor ] = pl.formValues
                    runcmd(`scoreboard players set plloc debug ${pl_floor+1}`)
                    runPermFunction(target, 'zz_games/lavafloor/start')
              })
            } else if (gm2.selection == 10) {
              game_description(`function zz_games/bw/start`, 'BedWars', '%xyz.minecrafter.mg.bw.description')
            } else if (gm2.selection == 0) {
                game_description(`function zz_games/microgm/start`, 'MicroGames', '%xyz.minecrafter.mg.microgm.description_ingame')
            } else if (gm2.selection == 1) {
                runcmd(`scoreboard players set sw_mode debug 2`)
                game_description(`function zz_games/sw/start`, 'SkyWars', '%xyz.minecrafter.mg.sw.description')
              }
          })
        }
        function form_1player(){
          f1pl.show(target).then(gm1 => {
            if (gm1.selection == 0) {
                f1pl_mn_start.show(target).then(arn => {
                    let arena = arn.selection
                    if (arena != undefined) {
                        f1pl_mn_start2.show(target).then(mn => {
                            if (mn.selection != undefined) {
                                runcmd(`scoreboard players set mndloc debug ${arena+1}`);
                                runcmd(`scoreboard players set mndif debug ${mn.selection}`);
                                runPermFunction(target, 'zz_games/mn/start')
                            }
                        })
                    }
                })
            } else if (gm1.selection == 1) {
              f1pl_prk_start.show(target).then(prk =>{
                    if (prk.selection != undefined) {
                        runcmd(`scoreboard players set g_par_loc debug ${prk.selection+1}`)
                        runPermFunction(target, 'zz_games/prk/start')
                    }
              })

            } else if (gm1.selection == 2) {
              game_description(`function zz_games/chick/start`, '%xyz.minecrafter.mg.chick', '%xyz.minecrafter.mg.chick.description')
            } else if (gm1.selection == 3) {
              game_description(`function zz_games/dropper/start`, '%xyz.minecrafter.mg.dropper', '%xyz.minecrafter.mg.dropper.description')
            } else if (gm1.selection == 4) {
              f1pl_gl_start.show(target).then(gl =>{
                    let [ gl_lives ] = gl.formValues
                    runcmd(`scoreboard players set "glass_hp" settings ${gl_lives}`)
                    runPermFunction(target, 'zz_games/sqg/glass/start')
              })
            } else if (gm1.selection == 5) {
              game_description(`function zz_games/sqg/ryg_light/start`, '%xyz.minecrafter.mg.squidgame.red_yellow_green_light', '%xyz.minecrafter.mg.squidgame.red_yellow_green_light.description')
            } else if (gm1.selection == 6) {
              game_description(`function zz_games/tntrun/start`, 'TNTRUN', '%xyz.minecrafter.mg.tntrun.description')
            }
          })
        }

    menu_gamesel.show(target).then(gm => {
        if (hasTag(target, 'perm_startgame')) {
          if (gm.selection == 0) {
            form_1player()
          } else if (gm.selection == 1 && Array.from(world.getPlayers()).length >= 2) {
            form_2players()
          } else if (gm.selection == 1 && Array.from(world.getPlayers()).length < 2) {
            fwarn_pl.show(target).then(gm2w => {if (gm2w.selection == 1) {form_2players()}})
          }
        } else {
          fwarn_perms.show(target).then(gmw => {if (gmw.selection == 1) {if (gm.selection == 0) {
            form_1player()
          } else if (gm.selection == 1 && Array.from(world.getPlayers()).length >= 2) {
            form_2players()
          } else if (gm.selection == 1 && Array.from(world.getPlayers()).length < 2) {
            fwarn_pl.show(target).then(gm2w => {if (gm2w.selection == 1) {form_2players()}})
          }}})
      }
    })
}


export {gameselect_form}