import {ActionFormData, ModalFormData} from "@minecraft/server-ui";
import {Dimension,Player,world} from "@minecraft/server";
import {runcmd, playsound, tellraw, randomInt, showCaptcha, getScore, runcmd_at} from '../AbstractTools.js'
import { iRUN } from "../AbstractChat/cmd/debug.js"


export function menu_donate(target){
    
    var name = target.nameTag

    const donate = new ActionFormData()
        .title("%xyz.minecrafter.button.donate")
        .body("%xyz.minecrafter.msg.donate.main\n§bhttps://axiscube.xyz/donate")
        .button('%selectWorld.learnMore', 'textures/ui/icons/donate.png')
        .button("_V-S_59\n $16", `textures/ui/icons/skin_picture/${randomInt(1, 2)}.png`)
        .button("Arseniy_L\n $15", `textures/ui/icons/skin_picture/${randomInt(1, 2)}.png`)
        .button(" Michael\n $5", `textures/ui/icons/skin_picture/${randomInt(1, 2)}.png`)
        .button("Guramchik\n $5", `textures/ui/icons/skin_picture/${randomInt(1, 2)}.png`)
        .button("Mikhail Silkov\n $0.8", `textures/ui/icons/skin_picture/${randomInt(1, 2)}.png`)
        .button("MRX\n $0.65", `textures/ui/icons/skin_picture/${randomInt(1, 2)}.png`)
        .button("Liverlik\n $0.5", `textures/ui/icons/skin_picture/${randomInt(1, 2)}.png`)
        .button("Karniz emae\n $0.25", `textures/ui/icons/skin_picture/${randomInt(1, 2)}.png`)
        .button("zxc zidofelon\n $0.15", `textures/ui/icons/skin_picture/${randomInt(1, 2)}.png`)
        .button("Cheharka\n $0.15", `textures/ui/icons/skin_picture/${randomInt(1, 2)}.png`)
        .button("Anonymous\n $0.15", `textures/ui/icons/skin_picture/${randomInt(1, 2)}.png`)

    donate.show(target).then(dn => {
        if (dn.selection == 0) tellraw('{"rawtext":[{"text":"§b"},{"text":"https://axiscube.xyz/donate"}]}', name)
    })
}

export function report_form(target){
    
    var name = target.nameTag

    const report_form = new ActionFormData()
        .title("%xyz.minecrafter.game_menu.report")
        .body("%xyz.minecrafter.game_menu.report.d")
        .button('%selectWorld.learnMore', 'textures/ui/icons/chat.png')


    report_form.show(target).then(rprt => {
        if (rprt.selection == 0) {
            tellraw('{"rawtext":[{"text":"§b"},{"text":"https://mcxyz.ru/r"}]}', name, name)
        }
    })
}

export function menu_info(target){

    var name = target.nameTag

    const info = new ActionFormData()
    .title("%manifestvalidation.info")
    .body(`\ue178 §4X§2Y§1Z §4M§6I§eN§aI§bG§3A§aM§5E§dS§r by §aAxis§bCube\n\n\ue177 §6Java§gScript§r by §aAbstract§2Scripts\n\n§rVersion: §b%mcxyz.version\n\n§rMAP ID: §a${getScore('debug2', 'map_id')}\n\n§bwww.axiscube.xyz`)
    .button("%store.search.filter.creator", "textures/ui/icons/creators/generic.png")
    .button("Discord\nmcxyz.ru/ds", "textures/ui/icons/social/discord.png")
    .button("VK\nvk.com/mcxyz", "textures/ui/icons/social/vk.png")
    .button("Telegram\nt.me/AxisCube", "textures/ui/icons/social/tg.png")
    .button("%gui.stats", "textures/items/book_portfolio")
    .button("§aAbstract§2Scripts§r\nscripting.js", "textures/ui/icons/js.png")
    .button("%xyz.minecrafter.game_menu.report", "textures/ui/icons/chat.png")
    .button("%xyz.minecrafter.button.donate", "textures/items/coin.png")
    .button("%howtoplay.whatsNew", "textures/ui/icons/update.png")
    .button("debug.info", "textures/ui/icons/console.png")

    const info_creators = new ActionFormData()
    .title("%manifestvalidation.info")
    .body("%store.search.filter.creator")
    .button("\ue1dc Axisander (AlexPro756)\n\ue178 %options.creator & All by a little", "textures/ui/icons/creators/axisander.png")//0
    .button("\ue1db olecssandr YT\n\ue178 %options.creator & %tile.command_block.name", "textures/ui/icons/creators/vs59.png")//1
    .button("\ue1dc Landarso\n\ue177 scripting.js", "textures/ui/icons/skin_picture/2.png")//2
    .button("\ue1dc Sofi4ka\nPixel artist (\ue1f1 \ue1e3 \ue1f7 \ue1f6)", "textures/ui/icons/creators/sofi4ka.png")//3
    .button("\ue1d9 MiauMiez\nGerman translator & Add-on", "textures/ui/icons/creators/miaumiez.png")//4
    .button("\ue1d7 Anna indev\nOther", "textures/ui/icons/skin_picture/1.png")//5
    .button("\ue1d8 Toni-Klark\nRender artist", "textures/ui/icons/creators/toni.png")//6
    .button("\ue1dc Cheharka\nPixel artist", "textures/ui/icons/creators/che.png")//7
    .button("\ue1db KotmanQwe\nUkrainian translator", "textures/ui/icons/creators/kotman.png")//8
    .button("\ue1dc 3nderboy\n%options.music & English proofreader", "textures/ui/icons/creators/endeboy.png")//9
    .button("\ue1dc pit1l3\nLogotype (\ue178)", "textures/ui/icons/creators/ddboy.png")//10
    .button("\ue1dd TechnyMarigold10\nProofreader (English)", "textures/ui/icons/skin_picture/2.png")//11
    .button("\ue1db FireSilver777\nBuilder", `textures/ui/icons/skin_picture/${randomInt(1, 2)}.png`)
    .button("\ue1dc Slakpake\nBuilder", `textures/ui/icons/skin_picture/${randomInt(1, 2)}.png`)
    .button("\ue1dc Ruslan2088\nBuilder", `textures/ui/icons/skin_picture/${randomInt(1, 2)}.png`)
    .button("\ue1dc XYZ Olivkus\nBuilder", `textures/ui/icons/skin_picture/${randomInt(1, 2)}.png`)
    .button("\ue1dc JustEgor\nBuilder", `textures/ui/icons/skin_picture/${randomInt(1, 2)}.png`)
    .button("\ue1dc FallyJay\nBuilder", `textures/ui/icons/skin_picture/${randomInt(1, 2)}.png`)
    .button("\ue1dc d1sk0teka\nBuilder", `textures/ui/icons/skin_picture/${randomInt(1, 2)}.png`)

    const info_axisander = new ActionFormData()
        .title('Axisander')
        .body(`Hi, I'm Axisander or Alexander.\n\nI live in Russia, I am one of the founders of AxisCube.\n\nI am responsible for almost everything that is possible.\n\nWebsite, Discord, Telegram and other social networks. In addons, I am responsible for JavaScript scripts (the AbtractScripts team), mcfunction's, entities, and generally everything`)
        .button('Website\naxiscube.xyz/axisander', 'textures/ui/icons/logo.png')
        .button('VK\nvk.com/axisander', 'textures/ui/icons/social/vk.png')
        .button('Discord\nmcxyz.ru/axi-ds', 'textures/ui/icons/social/discord.png')
        .button('Telegram\nt.me/axisander', 'textures/ui/icons/social/tg.png')
        .button('NameMC\nmine.ly/Axisander.1', 'textures/ui/icons/social/namemc.png')
    
    var time = new Date()
    const info_scripting = new ActionFormData()
    .title("\ue177 AbstractScripts")
    .body(`\ue177 %js.abstractscrpits.about\n\n§biCommand (v2.0.3)§r - chat commands\n\n§biCommandProMAX (v2.0.3.1)§r - chat commands for developers\n\n§bAbstractChat (v2.0.0)§r - Chat format\n\n§bAbstractUnicode (v1.1.0)§r - Turns :happy: into \ue1f5\n\n§bAbatractHealthBar (v1.3.0)§r - increases the number of lives your enemy has\n\ue1d4\ue1d4\ue1d4\ue1d6\ue1d5\n\n§bAbstractTools (v4.0.0)§r - tools that make life easier for script development\n\n§bAbstractStorage (v1.0.3)§r - scoreboard DataBase for developers.\n\n§bAbstractSTRGbaZZa (v16.0.0)§r - the nickname hashing system for encryption in the database.\n\nMeta:\n${time}`)
    .button("ScriptTest v1.0.0_DEV\n06.01.2023", `textures/ui/icons/js.png`)

    const info_dev = new ActionFormData()
    .title("\ue177 DevScriptTest 06.01.2023")
    .body("\ue177 ScriptTest 2.0.4")
    .button("pay.axiscube.xyz", `textures/ui/icons/skin_picture/${randomInt(1, 2)}.png`)
    .button("I'm not a zombie", `textures/ui/icons/skin_picture/${randomInt(1, 2)}.png`)
    .button("iForm", `textures/ui/icons/skin_picture/${randomInt(1, 2)}.png`)

    const info_dev_me = new ActionFormData()
    .title("HSTUUI")
    .body("\ue177 ScriptTest 2.0.4")
    .button("TEST UI", `textures/items/diamond`)

    const info_dev_pay = new ModalFormData()
    .title('AxisCubePay')
    .dropdown('Платежи на территории РФ осущесвляет ООО «ОСЬ КУБА».\nРоссия, Ленинградская область, г. Санкт-Петербург, ул. Шпалерная\n\nPayments on the territory of the Republic of Estonia, the European Union and other countries are processed by AxisCube Eesti LLC.\nRotermanni street, Tallinn, Estonia\n\n\nCountry', ["\ue1dc Russian Federation [RU]", "\ue1d8 European Union [EU]", "\ue1dd United States [US]", "\ue1da Spain [ES]", "\ue1d9 Germany [DE]", "\ue1df France [FR]", "\ue1d7 Estonia [EE]", "\ue1db Ukraine [UA]", "Other"], 1)
    .dropdown("Payment system", ["VISA", "MasterCard", "Mir", "AmericanExpress", "UnionPay", "JCB"])
    .textField('Card number', '4000 1234 5678 9012')
    .textField('Name', 'YOUR NAME')
    .dropdown("Expiration (MM)", ["01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12"])
    .dropdown("Expiration (YY)", ["22", "23", "24", "25", "26", "27", "28", "29", "30", "31", "32", "33"])
    .textField('CVC', "***")


    info.show(target).then(inf =>{
        if(inf.selection == 0){
            info_creators.show(target).then(gg => {if(gg.selection == 0){info_axisander.show(target).then(gg => {})}else if(gg.selection == 1){tellraw('{"rawtext":[{"text":"§bhttps://axiscube.xyz/olecssandr_yt"}]}', name)}else if(gg.selection == 2){tellraw('{"rawtext":[{"text":"Landarso: §bhttps://github.com/AbstractScripts"}]}', name)}else if(gg.selection == 5){tellraw('{"rawtext":[{"text":"Anna indev"}]}', name)}else if(gg.selection == 6){tellraw('{"rawtext":[{"text":"ToniKlark: §bhttps://mcxyz.ru/fiverr"}]}', name)}else if(gg.selection == 3){tellraw('{"rawtext":[{"text":"Sofi4ka: §bhttps://linktr.ee/sofi4ka"}]}', name)}else if(gg.selection == 7){tellraw('{"rawtext":[{"text":"Cheharka: §bhttps://vk.com/cheharka"}]}', name)}else if(gg.selection == 4){tellraw('{"rawtext":[{"text":"MiauMiez: §bhttps://linktr.ee/miaumiez"}]}', name)}else if(gg.selection == 8){tellraw('{"rawtext":[{"text":"KotmanQwe: §bhttps://vk.com/kotman120"}]}', name)}else if(gg.selection == 9){tellraw('{"rawtext":[{"text":"3nderboi: §bhttps://axiscube.xyz/3nderboi"}]}', name)}else if(gg.selection == 10){tellraw('{"rawtext":[{"text":"pit1l3: §bhttps://mine.ly/pit1l3.1"}]}', name)}})
        } else if(inf.selection == 1){
            tellraw('{"rawtext":[{"text":"\ue1dd Discord (English): "},{"text":"§bhttps://mcxyz.ru/dis-en §ror §bhttps://discord.gg/TH7fnWKXg5"}]}', name)
            tellraw('{"rawtext":[{"text":"\ue1dc Discord (Русский язык): "},{"text":"§bhttps://mcxyz.ru/dis-ru §ror §bhttps://discord.gg/4nAjZwzRQr"}]}', name)
        } else if(inf.selection == 2){
            tellraw('{"rawtext":[{"text":"VK: "},{"text":"§bhttps://vk.com/mcxyz §ror §b@mcxyz"}]}', name)
        } else if(inf.selection == 3){
            tellraw('{"rawtext":[{"text":"Telegram: "},{"text":"§bhttps://t.me/axiscube §ror §b@AxisCube"}]}', name)
        } else if(inf.selection == 4){
            runcmd_at(name, 'function zz_lk/stats')
            runcmd_at(name, 'function zz_lk/time')
        } else if(inf.selection == 5){
            info_scripting.show(target).then(gg => {
              if (gg.selection == 0) {
                info_dev.show(target).then(async gg => {
                    if(gg.selection == 0){
                        info_dev_pay.show(target).then(gg => {
                            tellraw(`{"rawtext":[{"text":"§bEncrypting..."}]}`, name)
                            tellraw(`{"rawtext":[{"text":"§bConnecting"}]}`, name)
                            tellraw(`{"rawtext":[{"text":"§rhttps://pay.axiscube.xyz/bill/api/r.§k${name}§r/§kUSERAPI§r/§k0089CB98-D993-44DF-B1F7-8CF7A202C603§r/u.php?data=[§k0089CB98-D993-44DF-B1F7-8CF7A202C603§r]"}]}`, name)
                            tellraw(`{"rawtext":[{"text":"§cError."}]}`, name)
                        })
                    }
                    else if(gg.selection == 1){
                        let answer
                       try{await showCaptcha(target, console.warn(answer))}catch(error){console.error(error)}
                    } else if(gg.selection == 2){
                      info_dev_me.show(target).then(gg => {})
                    }
                })
              }
            })
          } else if(inf.selection == 6){
          report_form(target)
        }
        else if(inf.selection == 7){
            menu_donate(target)
          }
        else if(inf.selection == 8){
          tellraw('{"rawtext":[{"text":"\ue1dd §r"},{"translate":"howtoplay.whatsNew"},{"text":": §bhttps://updates.axiscube.xyz/en/"},{"translate":"mcxyz.no_prefix"},{"translate":"mcxyz.prefix"}]}', name)
          tellraw('{"rawtext":[{"text":"\ue1dc §r"},{"translate":"howtoplay.whatsNew"},{"text":": §bhttps://updates.axiscube.xyz/ru/"},{"translate":"mcxyz.no_prefix"},{"translate":"mcxyz.prefix"}]}', name)
        } else if(inf.selection == 9){
            iRUN(target, 'null')
        }
    })
}

world.events.beforeItemUse.subscribe(eventData => {
    if(eventData.item.typeId == "mcxyz:donate_item"){
        menu_donate(eventData.source)
    }

})